(* Index Signature *)
(* Persistent *)
(* No deletion for simplicity *)
signature INDEX =
sig

  structure S : SET

  type index

  val empty : index
  val insert : index * Term.Term * S.set -> index

  val getEq : index -> Term.Term -> S.set
  val getGen : index -> Term.Term -> S.set
  val getInst : index -> Term.Term -> S.set
  val getUnif : index -> Term.Term -> S.set

end;  (* signature INDEX *)
